<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `/nix/store/kaan79bbbx80h17lcc5ay919l5r6bqlz-vendored-sources/postcard-1.0.1/src/error.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>error.rs - source</title><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Regular.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Medium.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Bold.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Semibold.ttf.woff2"><link rel="stylesheet" type="text/css" href="../../normalize.css"><link rel="stylesheet" type="text/css" href="../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../ayu.css" disabled><link rel="stylesheet" type="text/css" href="../../dark.css" disabled><link rel="stylesheet" type="text/css" href="../../light.css" id="themeStyle"><script id="default-settings" ></script><script src="../../storage.js"></script><script defer src="../../source-script.js"></script><script defer src="../../source-files.js"></script><script defer src="../../main.js"></script><noscript><link rel="stylesheet" href="../../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../../favicon.svg"></head><body class="rustdoc source"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="mobile-topbar"><button class="sidebar-menu-toggle">&#9776;</button><a class="sidebar-logo" href="../../postcard/index.html"><div class="logo-container"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></div>
        </a><h2 class="location"></h2>
    </nav>
    <nav class="sidebar"><a class="sidebar-logo" href="../../postcard/index.html"><div class="logo-container"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></div>
        </a></nav><main><div class="width-limiter"><div class="sub-container"><a class="sub-logo-container" href="../../postcard/index.html"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></a><nav class="sub"><form class="search-form"><div class="search-container"><span></span><input class="search-input" name="search" autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"><div id="help-button" title="help" tabindex="-1"><button type="button">?</button></div><div id="settings-menu" tabindex="-1">
                                <a href="../../settings.html" title="settings"><img width="22" height="22" alt="Change settings" src="../../wheel.svg"></a></div>
                        </div></form></nav></div><section id="main-content" class="content"><div class="example-wrap"><pre class="line-numbers"><span id="1">1</span>
<span id="2">2</span>
<span id="3">3</span>
<span id="4">4</span>
<span id="5">5</span>
<span id="6">6</span>
<span id="7">7</span>
<span id="8">8</span>
<span id="9">9</span>
<span id="10">10</span>
<span id="11">11</span>
<span id="12">12</span>
<span id="13">13</span>
<span id="14">14</span>
<span id="15">15</span>
<span id="16">16</span>
<span id="17">17</span>
<span id="18">18</span>
<span id="19">19</span>
<span id="20">20</span>
<span id="21">21</span>
<span id="22">22</span>
<span id="23">23</span>
<span id="24">24</span>
<span id="25">25</span>
<span id="26">26</span>
<span id="27">27</span>
<span id="28">28</span>
<span id="29">29</span>
<span id="30">30</span>
<span id="31">31</span>
<span id="32">32</span>
<span id="33">33</span>
<span id="34">34</span>
<span id="35">35</span>
<span id="36">36</span>
<span id="37">37</span>
<span id="38">38</span>
<span id="39">39</span>
<span id="40">40</span>
<span id="41">41</span>
<span id="42">42</span>
<span id="43">43</span>
<span id="44">44</span>
<span id="45">45</span>
<span id="46">46</span>
<span id="47">47</span>
<span id="48">48</span>
<span id="49">49</span>
<span id="50">50</span>
<span id="51">51</span>
<span id="52">52</span>
<span id="53">53</span>
<span id="54">54</span>
<span id="55">55</span>
<span id="56">56</span>
<span id="57">57</span>
<span id="58">58</span>
<span id="59">59</span>
<span id="60">60</span>
<span id="61">61</span>
<span id="62">62</span>
<span id="63">63</span>
<span id="64">64</span>
<span id="65">65</span>
<span id="66">66</span>
<span id="67">67</span>
<span id="68">68</span>
<span id="69">69</span>
<span id="70">70</span>
<span id="71">71</span>
<span id="72">72</span>
<span id="73">73</span>
<span id="74">74</span>
<span id="75">75</span>
<span id="76">76</span>
<span id="77">77</span>
<span id="78">78</span>
<span id="79">79</span>
<span id="80">80</span>
<span id="81">81</span>
<span id="82">82</span>
<span id="83">83</span>
<span id="84">84</span>
<span id="85">85</span>
<span id="86">86</span>
<span id="87">87</span>
<span id="88">88</span>
<span id="89">89</span>
<span id="90">90</span>
<span id="91">91</span>
<span id="92">92</span>
</pre><pre class="rust"><code><span class="kw">use</span> <span class="ident">core::fmt</span>::{<span class="ident">Display</span>, <span class="ident">Formatter</span>};

<span class="doccomment">/// This is the error type used by Postcard</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Clone</span>, <span class="ident">Debug</span>, <span class="ident">Eq</span>, <span class="ident">PartialEq</span>)]</span>
<span class="attribute">#[<span class="ident">cfg_attr</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;use-defmt&quot;</span>, <span class="ident">derive</span>(<span class="ident">defmt::Format</span>))]</span>
<span class="attribute">#[<span class="ident">non_exhaustive</span>]</span>
<span class="kw">pub</span> <span class="kw">enum</span> <span class="ident">Error</span> {
    <span class="doccomment">/// This is a feature that PostCard will never implement</span>
    <span class="ident">WontImplement</span>,
    <span class="doccomment">/// This is a feature that Postcard intends to support, but does not yet</span>
    <span class="ident">NotYetImplemented</span>,
    <span class="doccomment">/// The serialize buffer is full</span>
    <span class="ident">SerializeBufferFull</span>,
    <span class="doccomment">/// The length of a sequence must be known</span>
    <span class="ident">SerializeSeqLengthUnknown</span>,
    <span class="doccomment">/// Hit the end of buffer, expected more data</span>
    <span class="ident">DeserializeUnexpectedEnd</span>,
    <span class="doccomment">/// Found a varint that didn&#39;t terminate. Is the usize too big for this platform?</span>
    <span class="ident">DeserializeBadVarint</span>,
    <span class="doccomment">/// Found a bool that wasn&#39;t 0 or 1</span>
    <span class="ident">DeserializeBadBool</span>,
    <span class="doccomment">/// Found an invalid unicode char</span>
    <span class="ident">DeserializeBadChar</span>,
    <span class="doccomment">/// Tried to parse invalid utf-8</span>
    <span class="ident">DeserializeBadUtf8</span>,
    <span class="doccomment">/// Found an Option discriminant that wasn&#39;t 0 or 1</span>
    <span class="ident">DeserializeBadOption</span>,
    <span class="doccomment">/// Found an enum discriminant that was &gt; u32::max_value()</span>
    <span class="ident">DeserializeBadEnum</span>,
    <span class="doccomment">/// The original data was not well encoded</span>
    <span class="ident">DeserializeBadEncoding</span>,
    <span class="doccomment">/// Serde Serialization Error</span>
    <span class="ident">SerdeSerCustom</span>,
    <span class="doccomment">/// Serde Deserialization Error</span>
    <span class="ident">SerdeDeCustom</span>,
    <span class="doccomment">/// Error while processing `collect_str` during serialization</span>
    <span class="ident">CollectStrError</span>,
}

<span class="kw">impl</span> <span class="ident">Display</span> <span class="kw">for</span> <span class="ident">Error</span> {
    <span class="kw">fn</span> <span class="ident">fmt</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">f</span>: <span class="kw-2">&amp;mut</span> <span class="ident">Formatter</span>) -&gt; <span class="ident">core::fmt::Result</span> {
        <span class="kw">use</span> <span class="ident">Error</span>::<span class="kw-2">*</span>;
        <span class="macro">write!</span>(
            <span class="ident">f</span>,
            <span class="string">&quot;{}&quot;</span>,
            <span class="kw">match</span> <span class="self">self</span> {
                <span class="ident">WontImplement</span> =&gt; <span class="string">&quot;This is a feature that PostCard will never implement&quot;</span>,
                <span class="ident">NotYetImplemented</span> =&gt; {
                    <span class="string">&quot;This is a feature that Postcard intends to support, but does not yet&quot;</span>
                }
                <span class="ident">SerializeBufferFull</span> =&gt; <span class="string">&quot;The serialize buffer is full&quot;</span>,
                <span class="ident">SerializeSeqLengthUnknown</span> =&gt; <span class="string">&quot;The length of a sequence must be known&quot;</span>,
                <span class="ident">DeserializeUnexpectedEnd</span> =&gt; <span class="string">&quot;Hit the end of buffer, expected more data&quot;</span>,
                <span class="ident">DeserializeBadVarint</span> =&gt; {
                    <span class="string">&quot;Found a varint that didn&#39;t terminate. Is the usize too big for this platform?&quot;</span>
                }
                <span class="ident">DeserializeBadBool</span> =&gt; <span class="string">&quot;Found a bool that wasn&#39;t 0 or 1&quot;</span>,
                <span class="ident">DeserializeBadChar</span> =&gt; <span class="string">&quot;Found an invalid unicode char&quot;</span>,
                <span class="ident">DeserializeBadUtf8</span> =&gt; <span class="string">&quot;Tried to parse invalid utf-8&quot;</span>,
                <span class="ident">DeserializeBadOption</span> =&gt; <span class="string">&quot;Found an Option discriminant that wasn&#39;t 0 or 1&quot;</span>,
                <span class="ident">DeserializeBadEnum</span> =&gt; <span class="string">&quot;Found an enum discriminant that was &gt; u32::max_value()&quot;</span>,
                <span class="ident">DeserializeBadEncoding</span> =&gt; <span class="string">&quot;The original data was not well encoded&quot;</span>,
                <span class="ident">SerdeSerCustom</span> =&gt; <span class="string">&quot;Serde Serialization Error&quot;</span>,
                <span class="ident">SerdeDeCustom</span> =&gt; <span class="string">&quot;Serde Deserialization Error&quot;</span>,
                <span class="ident">CollectStrError</span> =&gt; <span class="string">&quot;Error while processing `collect_str` during serialization&quot;</span>,
            }
        )
    }
}

<span class="doccomment">/// This is the Result type used by Postcard.</span>
<span class="kw">pub</span> <span class="kw">type</span> <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="ident">T</span><span class="op">&gt;</span> <span class="op">=</span> <span class="ident">::core::result::Result</span><span class="op">&lt;</span><span class="ident">T</span>, <span class="ident">Error</span><span class="op">&gt;</span>;

<span class="kw">impl</span> <span class="ident">serde::ser::Error</span> <span class="kw">for</span> <span class="ident">Error</span> {
    <span class="kw">fn</span> <span class="ident">custom</span><span class="op">&lt;</span><span class="ident">T</span><span class="op">&gt;</span>(<span class="ident">_msg</span>: <span class="ident">T</span>) -&gt; <span class="self">Self</span>
    <span class="kw">where</span>
        <span class="ident">T</span>: <span class="ident">Display</span>,
    {
        <span class="ident">Error::SerdeSerCustom</span>
    }
}

<span class="kw">impl</span> <span class="ident">serde::de::Error</span> <span class="kw">for</span> <span class="ident">Error</span> {
    <span class="kw">fn</span> <span class="ident">custom</span><span class="op">&lt;</span><span class="ident">T</span><span class="op">&gt;</span>(<span class="ident">_msg</span>: <span class="ident">T</span>) -&gt; <span class="self">Self</span>
    <span class="kw">where</span>
        <span class="ident">T</span>: <span class="ident">Display</span>,
    {
        <span class="ident">Error::SerdeDeCustom</span>
    }
}

<span class="kw">impl</span> <span class="ident">serde::ser::StdError</span> <span class="kw">for</span> <span class="ident">Error</span> {}
</code></pre></div>
</section></div></main><div id="rustdoc-vars" data-root-path="../../" data-current-crate="postcard" data-themes="ayu,dark,light" data-resource-suffix="" data-rustdoc-version="1.64.0-dev" ></div>
</body></html>